package com.loafle.rpc.api;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.googlecode.jsonrpc4j.spring.AutoJsonRpcServiceImpl;
import com.loafle.rpc.crawler.Crawler;
import com.loafle.rpc.model.Input;
import com.loafle.rpc.model.Output;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@Service
@AutoJsonRpcServiceImpl
public class RemoteImpl implements Remote {

    private Map<String, Crawler> crawlerMap = null;


    @Override
    public Output init(String[] paths) throws JsonProcessingException {

        for (String v : paths) {
            System.out.println(v);
        }
        Output out = new Output();
        out.setStartDate(new Date());
        out.setEndDate(new Date());
        out.setData("Method init".getBytes());
        return out;
    }

    @Override
    public Output add(String type, String id) throws JsonProcessingException {
        return null;
    }

    @Override
    public int addDelegate(String name, Crawler crawler) {

        if(this.crawlerMap == null) {
            this.crawlerMap = new HashMap<String, Crawler>();
        }

        if(this.crawlerMap.containsKey(name)) {
            return 1;
        }

        this.crawlerMap.put(name, crawler);

        return 0;
    }

    @Override
    public Output get(String type, String id) throws JsonProcessingException {

        Crawler crawler = this.crawlerMap.get(type);
        if(crawler == null) {
            System.out.println(type + "_crawler == null");
        } else {
            return crawler.get(id);
        }

        System.out.println("type : " + type);
        System.out.println("id : " + id);
            Output out = new Output();
            out.setStartDate(new Date());
            out.setEndDate(new Date());
            out.setData("Not Delegate".getBytes());
            return out;
    }

    @Override
    public Output remove(String type, String id) throws JsonProcessingException {
        return null;
    }
}